package main

// Per compilare:
//     go mod init koch       <-- crea go.mod [SOLO UNA VOLTA]
//     go mod tidy            <-- scarica le librerie e aggiunge a go.mod le dipendenze
// Dopodiché solo "go build" o "go run"

import (
  "fmt"
  "net/http"
  "os"
  "math"
  "image"
  "image/png"
  "github.com/holizz/terrapin"  //<-importo un pacchetto non standard
      // Occorre installare git  ("Installare git sotto Windoze 11 / Mac Os / ...")
)


func pagePippo(w http.ResponseWriter, r *http.Request) {
  w.Write([]byte(`
      <!doctype html>
      <title>Pagina pippo</title>
      <h1>Pippo</h1>
      <p>Sono pippo e sono qui per prendermi cura di te&hellip;
      <p>Questo è un altro <b>paragrafo</b>

      <p><img src="/pluto">
    `))
}

func pagePluto(w http.ResponseWriter, r *http.Request) {
  f, err := os.Open("/Users/boldi/Desktop/Go/Server/neve.png")
  if err != nil {
    return
  }
  defer f.Close()
  image, _, err := image.Decode(f)
  png.Encode(w, image)
}

func kochCurve(t *terrapin.Terrapin, lung float64, liv int) {
  if liv == 0 {
    t.Forward(lung)
    return
  }
  kochCurve(t, lung, liv - 1)
  t.Left(math.Pi / 3)
  kochCurve(t, lung, liv - 1)
  t.Right(math.Pi - math.Pi / 3)
  kochCurve(t, lung, liv - 1)
  t.Left(math.Pi / 3)
  kochCurve(t, lung, liv - 1)
}

func kochImage(w http.ResponseWriter, r *http.Request) {
  i := image.NewRGBA(image.Rect(0, 0, 500, 500))
  t := terrapin.NewTerrapin(i, terrapin.Position{250.0, 450.0})

  kochCurve(t, 4.0, 4)

  png.Encode(w, i)
}

func main() {
  http.HandleFunc("/pippo", pagePippo)    // <---
  http.HandleFunc("/pluto", pagePluto)    // <---
  http.HandleFunc("/koch.png", kochImage) // <---

  fmt.Println("Listening on http://localhost:3000")
  http.ListenAndServe(":3000", nil)
}
